




<!DOCTYPE html>
<html>
<head>
<title>源码详解Pytorch的state_dict和load_state_dict -  码上快乐</title>
<meta name="keywords" content="Pytorch,机器学习,load_state_dict,pytorch" />
<meta name="description" content="在 Pytorch 中一种模型保存和加载的方式如下: model.state dict 其实返回的是一个OrderDict，存储了网络结构的名字和对应的参数，下面看看源代码如何实现的。 state dict 可以看到state dict函数中遍历了 中元素，分别是 paramters, buffer" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="源码详解Pytorch的state_dict和load_state_dict" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/b8415c1/源码详解Pytorch的state-dict和load-state-dict"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/b8415c1.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/b8415c1.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/b8415c1.html" style="color:black">源码详解Pytorch的state_dict和load_state_dict</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vbWFyc2dnYm8vcC8xMjA3NTM1Ni5odG1s" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2019-12-20 22:31</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>26204&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     <span><a href='/tag/Pytorch' target="_blank">Pytorch</a>/</span>
                                          
                     
                     <span><a href='/tag/机器学习' target="_blank">机器学习</a>/</span>
                                          
                     
                     <span><a href='/tag/load_state_dict' target="_blank">load_state_dict</a>/</span>
                                          
                     
                     
                     <span><a href='/tag/pytorch' target="_blank">pytorch</a></span>                     
                     
                  
                  <i class="icon-star" title="38.3071"></i>
                  <i class="icon-star" title="38.3071"></i>
                  <i class="icon-star" title="38.3071"></i>
                  <i class="icon-star" title="38.3071"></i>
                  <i class="icon-star" title="38.3071"></i>                  
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <p>在 Pytorch 中一种模型保存和加载的方式如下:</p> 
<pre><code class="language-python"># save
torch.save(model.state_dict(), PATH)

# load
model = MyModel(*args, **kwargs)
model.load_state_dict(torch.load(PATH))
model.eval()
</code></pre> 
<p><code>model.state_dict()</code>其实返回的是一个<code>OrderDict</code>，存储了网络结构的名字和对应的参数，下面看看源代码如何实现的。</p> 
<h1 id="state_dict">state_dict</h1> 
<pre><code class="language-python"># torch.nn.modules.module.py
class Module(object):
	def state_dict(self, destination=None, prefix='', keep_vars=False):
		if destination is None:
			destination = OrderedDict()
			destination._metadata = OrderedDict()
		destination._metadata[prefix[:-1]] = local_metadata = dict(version=self._version)
		for name, param in self._parameters.items():
			if param is not None:
				destination[prefix + name] = param if keep_vars else param.data
		for name, buf in self._buffers.items():
			if buf is not None:
				destination[prefix + name] = buf if keep_vars else buf.data
		for name, module in self._modules.items():
			if module is not None:
				module.state_dict(destination, prefix + name + '.', keep_vars=keep_vars)
		for hook in self._state_dict_hooks.values():
			hook_result = hook(self, destination, prefix, local_metadata)
			if hook_result is not None:
				destination = hook_result
		return destination
</code></pre>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>可以看到state_dict函数中遍历了4中元素，分别是<code>_paramters</code>,<code>_buffers</code>,<code>_modules</code>和<code>_state_dict_hooks</code>,前面三者在之前的<a href="/link/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vbWFyc2dnYm8vcC8xMjA3NTI0NC5odG1s" target="_blank" rel="nofollow noopener">文章</a>已经介绍区别，最后一种就是在读取<code>state_dict</code>时希望执行的操作，一般为空，所以不做考虑。另外有一点需要注意的是，在读取<code>Module</code>时采用的递归的读取方式，并且名字间使用<code>.</code>做分割，以方便后面<code>load_state_dict</code>读取参数。</p> 
<pre><code class="language-python">class MyModel(nn.Module):
	def __init__(self):
		super(MyModel, self).__init__()
		self.my_tensor = torch.randn(1) # 参数直接作为模型类成员变量
		self.register_buffer('my_buffer', torch.randn(1)) # 参数注册为 buffer
		self.my_param = nn.Parameter(torch.randn(1))
		self.fc = nn.Linear(2,2,bias=False)
		self.conv = nn.Conv2d(2,1,1)
		self.fc2 = nn.Linear(2,2,bias=False)
		self.f3 = self.fc
	def forward(self, x):
		return x

model = MyModel()
print(model.state_dict())
&gt;&gt;&gt;OrderedDict([('my_param', tensor([-0.3052])), ('my_buffer', tensor([0.5583])), ('fc.weight', tensor([[ 0.6322, -0.0255],
        [-0.4747, -0.0530]])), ('conv.weight', tensor([[[[ 0.3346]],

         [[-0.2962]]]])), ('conv.bias', tensor([0.5205])), ('fc2.weight', tensor([[-0.4949,  0.2815],
        [ 0.3006,  0.0768]])), ('f3.weight', tensor([[ 0.6322, -0.0255],
        [-0.4747, -0.0530]]))])
</code></pre> 
<p>可以看到最后的确输出了三种参数。</p> 
<h1 id="load_state_dict">load_state_dict</h1>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>下面的代码中我们可以分成两个部分看，</p> 
<ol> 
 <li><code>load(self)</code></li> 
</ol> 
<p>这个函数会递归地对模型进行参数恢复，其中的<code>_load_from_state_dict</code>的源码附在文末。</p> 
<p>首先我们需要明确<code>state_dict</code>这个变量表示你之前保存的模型参数序列，而<code>_load_from_state_dict</code>函数中的<code>local_state </code>表示你的代码中定义的模型的结构。</p> 
<p>那么<code>_load_from_state_dict</code>的作用简单理解就是假如我们现在需要对一个名为<code>conv.weight</code>的子模块做参数恢复，那么就以递归的方式先判断<code>conv</code>是否在<code>staet__dict</code>和<code>local_state</code>中，如果不在就把<code>conv</code>添加到<code>unexpected_keys</code>中去，否则递归的判断<code>conv.weight</code>是否存在，如果都存在就执行<code>param.copy_(input_param)</code>,这样就完成了<code>conv.weight</code>的参数拷贝。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<ol start="2"> 
 <li><code>if strict：</code></li> 
</ol> 
<p>这个部分的作用是判断上面参数拷贝过程中是否有<code>unexpected_keys</code>或者<code>missing_keys</code>,如果有就报错，代码不能继续执行。当然，如果<code>strict=False</code>，则会忽略这些细节。</p> 
<pre><code class="language-python">def load_state_dict(self, state_dict, strict=True):
	missing_keys = []
	unexpected_keys = []
	error_msgs = []

	# copy state_dict so _load_from_state_dict can modify it
	metadata = getattr(state_dict, '_metadata', None)
	state_dict = state_dict.copy()
	if metadata is not None:
		state_dict._metadata = metadata

	def load(module, prefix=''):
		local_metadata = {} if metadata is None else metadata.get(prefix[:-1], {})
		module._load_from_state_dict(
			state_dict, prefix, local_metadata, strict, missing_keys, unexpected_keys, error_msgs)
		for name, child in module._modules.items():
			if child is not None:
				load(child, prefix + name + '.')

	load(self)

	if strict:
		error_msg = ''
		if len(unexpected_keys) &gt; 0:
			error_msgs.insert(
				0, 'Unexpected key(s) in state_dict: {}. '.format(
					', '.join('"{}"'.format(k) for k in unexpected_keys)))
		if len(missing_keys) &gt; 0:
			error_msgs.insert(
				0, 'Missing key(s) in state_dict: {}. '.format(
					', '.join('"{}"'.format(k) for k in missing_keys)))

	if len(error_msgs) &gt; 0:
		raise RuntimeError('Error(s) in loading state_dict for {}:\n\t{}'.format(
						   self.__class__.__name__, "\n\t".join(error_msgs)))
</code></pre> 
<ul> 
 <li><code>_load_from_state_dict</code></li> 
</ul>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code class="language-python">def _load_from_state_dict(self, state_dict, prefix, local_metadata, strict,
						  missing_keys, unexpected_keys, error_msgs):
	for hook in self._load_state_dict_pre_hooks.values():
		hook(state_dict, prefix, local_metadata, strict, missing_keys, unexpected_keys, error_msgs)

	local_name_params = itertools.chain(self._parameters.items(), self._buffers.items())
	local_state = {k: v.data for k, v in local_name_params if v is not None}

	for name, param in local_state.items():
		key = prefix + name
		if key in state_dict:
			input_param = state_dict[key]

			# Backward compatibility: loading 1-dim tensor from 0.3.* to version 0.4+
			if len(param.shape) == 0 and len(input_param.shape) == 1:
				input_param = input_param[0]

			if input_param.shape != param.shape:
				# local shape should match the one in checkpoint
				error_msgs.append('size mismatch for {}: copying a param with shape {} from checkpoint, '
								  'the shape in current model is {}.'
								  .format(key, input_param.shape, param.shape))
				continue

			if isinstance(input_param, Parameter):
				# backwards compatibility for serialized parameters
				input_param = input_param.data
			try:
				param.copy_(input_param)
			except Exception:
				error_msgs.append('While copying the parameter named "{}", '
								  'whose dimensions in the model are {} and '
								  'whose dimensions in the checkpoint are {}.'
								  .format(key, param.size(), input_param.size()))
		elif strict:
			missing_keys.append(key)

	if strict:
		for key, input_param in state_dict.items():
			if key.startswith(prefix):
				input_name = key[len(prefix):]
				input_name = input_name.split('.', 1)[0]  # get the name of param/buffer/child
				if input_name not in self._modules and input_name not in local_state:
					unexpected_keys.append(key)

</code></pre> 
<footer style="color: rgba(255, 255, 255, 1); background-color: rgba(24, 24, 24, 1); padding: 10px; border-radius: 10px"> 
 <br> 
 <h3 style="text-align: center; color: rgba(255, 99, 71, 1); font-size: 16px" id="autoid-2-0-0"><br> 
  <center> 
   <span>微信公众号：AutoML机器学习</span> 
   <br> 
   <img src="/image/aHR0cHM6Ly9hc2sucWNsb3VkaW1nLmNvbS9kcmFmdC8xMjE1MDA0LzIxcmE4MmF4bnouanBn.png" style="width: 200px; height: 200px" referrerpolicy="no-referrer"> 
  </center> <b>MARSGGBO</b><b style="color: rgba(255, 255, 255, 1)"><span style="font-size: 25px">♥</span>原创</b><br> <span>如有意合作或学术讨论欢迎私戳联系~<br>邮箱:marsggbo@foxmail.com</span> <br><br> <p>如有意合作，欢迎私戳</p> <p>邮箱:marsggbo@foxmail.com</p> <b style="color: rgba(255, 255, 255, 1)"><br> 2019-12-20 21:55:21 <p></p> </b><p><b style="color: rgba(255, 255, 255, 1)"></b><br> </p></h3> 
 <br> 
</footer>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/cd564b1.html" title="【PyTorch】state_dict详解">
			           
			           <i class="icon-file"></i>
			           【PyTorch】state_dict详解
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/ceac291.html" title="state_dict详解">
			           <i class="icon-fire"></i>
			           
			           state_dict详解
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/aba2e91.html" title="pytorch的state_dict()拷贝问题">
			           <i class="icon-fire"></i>
			           
			           pytorch的state_dict()拷贝问题
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9f38901.html" title="pytorch错误：Missing key(s) in state_dict、Unexpected key(s) in state_dict解决">
			           <i class="icon-fire"></i>
			           
			           pytorch错误：Missing key(s) in state_dict、Unexpected key(s) in state_dict解决
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/aad00a1.html" title="pytorch 状态字典:state_dict 模型和参数保存">
			           <i class="icon-fire"></i>
			           
			           pytorch 状态字典:state_dict 模型和参数保存
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/a888ca1.html" title="Missing key(s) in state_dict: Unexpected key(s) in state_dict">
			           <i class="icon-fire"></i>
			           
			           Missing key(s) in state_dict: Unexpected key(s) in state_dict
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/e31eec1.html" title="Pytorch：模型的保存与加载 torch.load()、torch.nn.Module.load_state_dict()">
			           <i class="icon-fire"></i>
			           
			           Pytorch：模型的保存与加载 torch.load()、torch.nn.Module.load_state_dict()
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/f4f26d1.html" title="小记named_modules(),named_parameters(),state_dict()；以及如何部分初始化网络">
			           
			           <i class="icon-file"></i>
			           小记named_modules(),named_parameters(),state_dict()；以及如何部分初始化网络
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/cce6a31.html" title="optimizer.state_dict()、optimizer.param_groups">
			           
			           <i class="icon-file"></i>
			           optimizer.state_dict()、optimizer.param_groups
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/6398e51.html" title="dict">
			           
			           <i class="icon-file"></i>
			           dict
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240329"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>